'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var PdfJsLib = _interopDefault(require('pdfjs-dist'));
var PropTypes = _interopDefault(require('prop-types'));
var React = require('react');
var React__default = _interopDefault(React);

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

/**
 * @class ReactPdfJs
 */

var ReactPdfJs = function (_Component) {
  inherits(ReactPdfJs, _Component);

  function ReactPdfJs() {
    var _ref;

    var _temp, _this, _ret;

    classCallCheck(this, ReactPdfJs);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = possibleConstructorReturn(this, (_ref = ReactPdfJs.__proto__ || Object.getPrototypeOf(ReactPdfJs)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      pdf: null
    }, _temp), possibleConstructorReturn(_this, _ret);
  }

  createClass(ReactPdfJs, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      PdfJsLib.GlobalWorkerOptions.workerSrc = '//cdnjs.cloudflare.com/ajax/libs/pdf.js/2.0.550/pdf.worker.js';
      PdfJsLib.getDocument(this.props.file).then(function (pdf) {
        _this2.setState({ pdf: pdf });
        _this2.props.onDocumentCompleted(pdf);
        pdf.getPage(_this2.props.page).then(function (page) {
          var scale = 1.5;
          var viewport = page.getViewport(scale);

          var canvas = _this2.canvas;

          var canvasContext = canvas.getContext('2d');
          canvas.height = viewport.height;
          canvas.width = viewport.width;

          var renderContext = {
            canvasContext: canvasContext,
            viewport: viewport
          };
          page.render(renderContext);
        });
      });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      var _this3 = this;

      if (newProps.page !== this.props.page) {
        this.state.pdf.getPage(newProps.page).then(function (page) {
          var scale = 1.5;
          var viewport = page.getViewport(scale);

          var canvas = _this3.canvas;

          var canvasContext = canvas.getContext('2d');
          canvas.height = viewport.height;
          canvas.width = viewport.width;

          var renderContext = {
            canvasContext: canvasContext,
            viewport: viewport
          };
          page.render(renderContext);
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      return React__default.createElement('canvas', { ref: function ref(canvas) {
          _this4.canvas = canvas;
        } });
    }
  }]);
  return ReactPdfJs;
}(React.Component);

ReactPdfJs.propTypes = {
  file: PropTypes.string.isRequired,
  page: PropTypes.number,
  onDocumentCompleted: PropTypes.func
};
ReactPdfJs.defaultProps = {
  page: 1,
  onDocumentCompleted: null
};

module.exports = ReactPdfJs;
